package com.ekexiu.console.system.dao;

import java.sql.Connection;
import java.sql.SQLException;

import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.orm.annotation.dao.Batch;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.OrderBy;
import org.jfw.apt.orm.annotation.dao.method.operator.DeleteWith;
import org.jfw.apt.orm.annotation.dao.method.operator.Insert;
import org.jfw.apt.orm.annotation.dao.method.operator.PageSelect;
import org.jfw.apt.orm.annotation.dao.method.operator.SelectOne;
import org.jfw.apt.orm.annotation.dao.method.operator.Update;
import org.jfw.apt.orm.annotation.dao.param.Alias;
import org.jfw.apt.orm.annotation.dao.param.GtEq;
import org.jfw.apt.orm.annotation.dao.param.Like;
import org.jfw.apt.orm.annotation.dao.param.LtEq;
import org.jfw.util.PageQueryResult;

import com.ekexiu.console.system.po.Organization;

@DAO
public interface OrgDao {
	@Insert
	int insert(Connection con, Organization org) throws SQLException;

	@Update
	int update(Connection con, Organization org) throws SQLException;

	@DeleteWith
	@From(Organization.class)
	int delete(Connection con, String id) throws SQLException;
	
	@DeleteWith
	@Batch
	@From(Organization.class)
	int[] delete(Connection con, @Batch String[] id) throws SQLException;

	@Nullable
	@SelectOne
	Organization query(Connection con, String id) throws SQLException;

	@PageSelect
	@OrderBy(" ORDER BY NAME")
	PageQueryResult<Organization> query(Connection con, @Nullable @Like String name, @Nullable String type, @GtEq @Nullable @Alias("createTime") String bt,
			@LtEq @Nullable @Alias("createTime") String et, int pageSize, int pageNo) throws SQLException;

}
