package com.ekexiu.console.system.dao;

import java.sql.Connection;
import java.sql.SQLException;

import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.IncludeFixSet;
import org.jfw.apt.orm.annotation.dao.method.Or;
import org.jfw.apt.orm.annotation.dao.method.SetSentence;
import org.jfw.apt.orm.annotation.dao.method.Where;
import org.jfw.apt.orm.annotation.dao.method.operator.Insert;
import org.jfw.apt.orm.annotation.dao.method.operator.SelectOne;
import org.jfw.apt.orm.annotation.dao.method.operator.Update;
import org.jfw.apt.orm.annotation.dao.method.operator.UpdateWith;
import org.jfw.apt.orm.annotation.dao.param.Alias;
import org.jfw.apt.orm.annotation.dao.param.Set;

import com.ekexiu.console.system.po.User;

@DAO
public interface UserDao {
	
	@Insert
	int insert(Connection con,User user)throws SQLException;

	@Nullable
	@SelectOne
	User queryById(Connection con, String id) throws SQLException;

	@Or
	@Nullable
	@SelectOne
	User queryByLoginKey(Connection con, @Alias({ "mobile", "email" }) String key) throws SQLException;

	@Update
	int update(Connection con, User user) throws SQLException;

	@IncludeFixSet("modifyTime")
	@UpdateWith
	@From(User.class)
	int update(Connection con, String id, @Set String authinfo) throws SQLException;

	@Where("ACTIVED<>'1'")
	@SetSentence("ACTIVED='1'")
	@IncludeFixSet("modifyTime")
	@From(User.class)
	@UpdateWith
	int enable(Connection con, String id) throws SQLException;

	@Where("ACTIVED='1'")
	@SetSentence("ACTIVED='0'")
	@IncludeFixSet("modifyTime")
	@From(User.class)
	@UpdateWith
	int dsiable(Connection con, String id) throws SQLException;

}
