package com.ekexiu.console.system.service;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.ArrayList;

import org.jfw.apt.annotation.Autowrie;
import org.jfw.apt.web.annotation.Path;
import org.jfw.apt.web.annotation.method.SetSession;
import org.jfw.apt.web.annotation.operate.Post;
import org.jfw.apt.web.annotation.param.JdbcConn;
import org.jfw.util.StringUtil;
import org.jfw.util.auth.AuthUtil;

import com.ekexiu.console.system.dao.RoleDao;
import com.ekexiu.console.system.dao.UserDao;
import com.ekexiu.console.system.po.Role;
import com.ekexiu.console.system.po.User;
import com.ekexiu.console.system.vo.ConsoleAuthUser;

@Path("/sys/user")
public class UserService {

	@Autowrie
	private UserDao userDao;
	@Autowrie
	RoleDao roleDao;

	public RoleDao getRoleDao() {
		return roleDao;
	}

	public void setRoleDao(RoleDao roleDao) {
		this.roleDao = roleDao;
	}

	public UserDao getUserDao() {
		return userDao;
	}

	public void setUserDao(UserDao userDao) {
		this.userDao = userDao;
	}

	@SetSession("JFW_SESSION_LOGIN_USER=result")
	@Path("/login")
	@Post
	public ConsoleAuthUser login(@JdbcConn Connection con, String key, String pw) throws SQLException {
		User user = userDao.queryByLoginKey(con, key);
		if (user != null && StringUtil.md5(pw).equals(user.getLoginPassword()) && user.isActived()) {
			ConsoleAuthUser cau = new ConsoleAuthUser(user);
			cau.setHead(user.getHead());
			cau.setId(user.getId());
			cau.setName(user.getName());
			ArrayList<int[]> list = new ArrayList<int[]>(1);
			list.add(AuthUtil.deSerialAuth(user.getAuthinfo()));
			for(Role role:this.roleDao.queryByUser(con,user.getId())){
				list.add(AuthUtil.deSerialAuth(role.getAuthinfo()));
			}
			cau.setAuths(AuthUtil.merge(list.toArray(new int[0][0])));
			return cau;
		}
		return null;
	}
	public static void main(String[] args)throws Exception{
		System.out.println(AuthUtil.serialAuth(new int[]{0}));
	}
}
